create or replace
FUNCTION ARQUIVO_DCTF_R33 (
      P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
      P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
      P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
      P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
      P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
      P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
      V_IRPJ         VARCHAR2,
      V_IRRF         VARCHAR2,
      V_IPI          VARCHAR2, 
      V_IOF          VARCHAR2,
      V_CSLL         VARCHAR2,
      V_PIS          VARCHAR2,
      V_COFINS       VARCHAR2,
      V_CPMF         VARCHAR2,
      V_CIDE         VARCHAR2,
      V_RET          VARCHAR2,
      V_CSRF         VARCHAR2,
      V_COSIRF       VARCHAR2,
      V_CPSSS        VARCHAR2)RETURN NUMBER
AS 
V_CONTREGAR33   NUMBER;
V_CDRECEITA    VARCHAR2(6);
BEGIN
         FOR C_REG_33_IRPJ IN( SELECT (RPAD('R33',3,' '))                                                                           ||/*REGISTRO*/
                                      LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                      TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                 ||/*ANO/MES*/
                                      P_SITUACAO                                                                                    ||/*SITUACAO*/
                                      DECODE(P_SITUACAO,'0','00000000', TO_CHAR(P_DTINICIAL,'DDMMYYYY'))                            ||/*DATA DO EVENTO*/
                                      V_IRPJ                                                                                        ||/*TRIBUTO*/
                                      CDRECEGUIA||CDVARIACAO                                                                        ||/*CODIGO DA RECEITA*/
                                      IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                      TO_CHAR(P_DTINICIAL,'YYYY')                                                                   ||/*ANO DE APURACAO*/
                                      DECODE(TO_CHAR(P_DTINICIAL,'MM'),'03','04',DECODE(TO_CHAR(P_DTINICIAL,'MM'),'06','01',DECODE(TO_CHAR(P_DTINICIAL,'MM'),'09','02','04')))||/*TRIMESTRE*/
                                      '00'                                                                                          ||/*RESERVADO*/
                                      '000000'                                                                                      ||/*RESERVADO*/
                                      RPAD('0',14,0)                                                                                ||/*RESERVADO*/
                                      '0'                                                                                           ||/*RESERVADO*/
                                      NRPROCESSOGUIA                                                                                ||/*N PROCESSO*/
                                      LPAD(LTRIM(REPLACE(TO_CHAR(VRPARCELA,'000000000000.00'),'.')),'14','0')                       ||/*VALOR PARCELADO DO DEBITO*/
                                      RPAD(' ',10,' ')    AS REG_33_IRPJ                                                                                                                                       
                                    FROM (SELECT SUM(VRORIGPAG) AS VRPARCELA,E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC,  MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG 
                                            FROM EMPRESA E , MAPAAPURAC MP, GUIACOMPLMAPA G, CONTAPAGAR CP
                                            WHERE MP.CDEMPRESA  = E.CDEMPRESA
                                            AND E.CDEMPRESA     = P_CDEMPRESA
                                            AND MP.DTINIPERIODO = P_DTINICIAL
                                            AND MP.DTFIMPERIODO = P_DTFINAL
                                            AND MP.CDIMPOSTO    = '25'
                                            AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU(+)
                                            AND CP.DSCONTAPAG   = MP.NMMAPAAPUR
                                          GROUP BY E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC,  MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG))LOOP
                     V_CONTREGAR33 := NVL(V_CONTREGAR33,0)+1;
              INSERT INTO ARQMAGNETICO(NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                     VALUES('04'||LPAD(RTRIM(V_CONTREGAR33), 8, '0'), C_REG_33_IRPJ.REG_33_IRPJ, P_NRSEQARQMAG);
         END LOOP;
         FOR C_REG_33_CSLL IN( SELECT (RPAD('R33',3,' '))                                                                           ||/*REGISTRO*/
                                      LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                      TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                 ||/*ANO/MES*/
                                      P_SITUACAO                                                                                    ||/*SITUACAO*/
                                      DECODE(P_SITUACAO,'0','00000000', TO_CHAR(P_DTINICIAL,'DDMMYYYY'))                            ||/*DATA DO EVENTO*/
                                      V_CSLL                                                                                        ||/*TRIBUTO*/
                                      CDRECEGUIA||CDVARIACAO                                                                        ||/*CODIGO DA RECEITA*/
                                      IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                      TO_CHAR(P_DTINICIAL,'YYYY')                                                                   ||/*ANO DE APURACAO*/
                                      DECODE(TO_CHAR(P_DTINICIAL,'MM'),'03','04',DECODE(TO_CHAR(P_DTINICIAL,'MM'),'06','01',DECODE(TO_CHAR(P_DTINICIAL,'MM'),'09','02','04')))||/*TRIMESTRE*/
                                      '00'                                                                                          ||/*RESERVADO*/
                                      '000000'                                                                                      ||/*RESERVADO*/
                                      RPAD('0',14,0)                                                                                ||/*RESERVADO*/
                                      '0'                                                                                           ||/*RESERVADO*/
                                      NRPROCESSOGUIA                                                                                ||/*N PROCESSO*/
                                      LPAD(LTRIM(REPLACE(TO_CHAR(VRPARCELA,'000000000000.00'),'.')),'14','0')                       ||/*VALOR PARCELADO DO DEBITO*/
                                      RPAD(' ',10,' ')    AS REG_33_CSLL                                                                                                                                       
                                    FROM (SELECT SUM(VRORIGPAG) AS VRPARCELA,E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC,  MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG 
                                            FROM EMPRESA E , MAPAAPURAC MP, GUIACOMPLMAPA G, CONTAPAGAR CP
                                            WHERE MP.CDEMPRESA  = E.CDEMPRESA
                                            AND E.CDEMPRESA     = P_CDEMPRESA
                                            AND MP.DTINIPERIODO = P_DTINICIAL
                                            AND MP.DTFIMPERIODO = P_DTFINAL
                                            AND MP.CDIMPOSTO    = '70'
                                            AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU(+)
                                            AND CP.DSCONTAPAG   = MP.NMMAPAAPUR
                                          GROUP BY E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC,  MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG))LOOP
                     V_CONTREGAR33 := NVL(V_CONTREGAR33,0)+1;
              INSERT INTO ARQMAGNETICO(NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                     VALUES('10'||LPAD(RTRIM(V_CONTREGAR33), 8, '0'), C_REG_33_CSLL.REG_33_CSLL, P_NRSEQARQMAG);
         END LOOP;                                           
  RETURN V_CONTREGAR33 ;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DCTF_R33','5.03.034'); END;
/