CREATE OR REPLACE
PROCEDURE EXP_ITEMAUTFDEST_NGD
IS
  V_ERRO         VARCHAR2(300);
  V_CONTADOR     FLOAT := 0;
  V_CHAVE        VARCHAR2(300) := '';
BEGIN
   FOR C_FILIAL IN
      (SELECT CDFILIAL, NMFILIAL, CDREGIAO
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') <> 'O')
   LOOP
      FOR C_PRODUTOS IN
         (SELECT FILIAL.CDFILIAL CDFILIOPELOG, PRODUTOOL.CDARVPROD, AUTOFORNE.CDFILDEST, ITEMAUTF.CDPRODUTO,
                 TO_CHAR(ITEMAUTF.DTPROGENTAF, 'YYYYMMDD') DTPROGENTAF, ITEMAUTF.DTPROGENTAF DTPROGENTAF_1,
                 SUM(CASE
                    WHEN NVL(ITEMAUTF.QTPROGENTAF, 0) < NVL(ITEMAUTF.QTEFETENTRAF, 0)
                    THEN 0
                    ELSE NVL(ITEMAUTF.QTPROGENTAF, 0) - NVL(ITEMAUTF.QTEFETENTRAF, 0)
                 END) QTPROGENTAF
            FROM PRODUTO PRODUTOOL, RELACPRODOL,
                 ITEMAUTF, AUTOFORNE, FILIAL
           WHERE ITEMAUTF.CDFILDEST      = AUTOFORNE.CDFILDEST
             AND ITEMAUTF.CDFILLANC      = AUTOFORNE.CDFILLANC
             AND ITEMAUTF.NRAUTOFORN     = AUTOFORNE.NRAUTOFORN
             AND ITEMAUTF.CDPRODUTO      = RELACPRODOL.CDPRARVORIG
             AND RELACPRODOL.CDPRODARVOL = PRODUTOOL.CDPRODUTO
             AND ITEMAUTF.CDFILDEST      = C_FILIAL.CDFILIAL
             AND AUTOFORNE.CDFILIOPELOG  = FILIAL.CDFILIAL
             AND NVL(FILIAL.IDCNTRRESC, 'N')      <> 'S'
             AND NVL(FILIAL.IDFUNCAOFILI, 'T')    = 'O'
             AND NVL(AUTOFORNE.IDBAIXAAF, '1')    = '1'
             AND NVL(AUTOFORNE.IDSITUATUAAF, '1') = '1'
             AND NVL(AUTOFORNE.IDAFFORALIM, 'N')  = 'N'
             AND NVL(AUTOFORNE.IDAFCONS, 'N')     = 'N'
             AND NVL(AUTOFORNE.IDAFEXPIRADA, 'N') = 'N'
             AND AUTOFORNE.CDFILIOPELOG IS NOT NULL
             AND AUTOFORNE.DTAUTOFORN >= SYSDATE - 732
             AND NVL(ITEMAUTF.IDBAIXITMAF, '1')   = '1'
             AND NVL(ITEMAUTF.QTPROGENTAF, 0)     > 0
             AND ITEMAUTF.DTPROGENTAF > SYSDATE
             AND ((NVL(AUTOFORNE.USR_NGD_INTEGRADO, 'N') = 'N') OR (NVL(ITEMAUTF.USR_NGD_INTEGRADO, 'N') = 'N'))
           GROUP BY FILIAL.CDFILIAL, PRODUTOOL.CDARVPROD, AUTOFORNE.CDFILDEST,
                    ITEMAUTF.CDPRODUTO, ITEMAUTF.DTPROGENTAF
           ORDER BY AUTOFORNE.CDFILDEST, ITEMAUTF.DTPROGENTAF, PRODUTOOL.CDARVPROD
         )
      LOOP
         V_CONTADOR := V_CONTADOR + 1;
         IF V_CONTADOR >= 500 THEN
            V_CONTADOR := 0;
            COMMIT;
         END IF;
         BEGIN
            UPDATE USR_ITEMAUTFDEST_NGD
               SET QTPROGENTAF        = C_PRODUTOS.QTPROGENTAF,
                   TPINTERFACE        = 'A',
                   DTINTERFACEORI     = SYSDATE,
                   DTINTERFACEDEST    = NULL,
                   STATUS             = '1'
             WHERE USR_ITEMAUTFDEST_NGD.CDFILIOPELOG   = C_PRODUTOS.CDFILIOPELOG
               AND USR_ITEMAUTFDEST_NGD.CDARVPROD      = C_PRODUTOS.CDARVPROD
               AND USR_ITEMAUTFDEST_NGD.CDFILDEST      = C_PRODUTOS.CDFILDEST
               AND USR_ITEMAUTFDEST_NGD.DTPROGENTAF    = C_PRODUTOS.DTPROGENTAF;
            IF SQL%NOTFOUND THEN
               INSERT
                INTO USR_ITEMAUTFDEST_NGD(CDFILIOPELOG, CDARVPROD, CDFILDEST, DTPROGENTAF,
                                          COMPONENTE, QTPROGENTAF, NMFILIAL, IDSTATUSITMAF,
                                          TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS)
               VALUES (C_PRODUTOS.CDFILIOPELOG, C_PRODUTOS.CDARVPROD, C_PRODUTOS.CDFILDEST, C_PRODUTOS.DTPROGENTAF,
                       'CARDAPIO', C_PRODUTOS.QTPROGENTAF, C_FILIAL.NMFILIAL, 'ATIVO',
                       'I', 	SYSDATE,	NULL,	'1');
            END IF;

            FOR C_ITEMAUTF IN(SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, CDMARCA, DTPROGENTAF
                                FROM ITEMAUTF
                               WHERE CDFILDEST   = C_PRODUTOS.CDFILDEST
                                 AND CDPRODUTO   = C_PRODUTOS.CDPRODUTO
                                 AND DTPROGENTAF = C_PRODUTOS.DTPROGENTAF_1
                               ORDER BY CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO)
            LOOP
               UPDATE ITEMAUTF
                  SET USR_NGD_INTEGRADO = 'S'
                WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                  AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                  AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
                  AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
                  AND CDMARCA     = C_ITEMAUTF.CDMARCA
                  AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF;
               IF V_CHAVE <> C_ITEMAUTF.CDFILDEST||C_ITEMAUTF.CDFILLANC||C_ITEMAUTF.NRAUTOFORN THEN
                  V_CHAVE := C_ITEMAUTF.CDFILDEST||C_ITEMAUTF.CDFILLANC||C_ITEMAUTF.NRAUTOFORN;
                  UPDATE AUTOFORNE
                     SET USR_NGD_INTEGRADO = 'S'
                   WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                     AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                     AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN;
               END IF;
            END LOOP;   
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '0',
                   OBSSTATUS  = NULL
             WHERE IDPROCESSO = 'USR_ITEMAUTFDEST_NGD'
               AND IDPESQITEM = C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.CDFILDEST||'-'||C_PRODUTOS.DTPROGENTAF;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '0', NULL, C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.CDFILDEST||'-'||C_PRODUTOS.DTPROGENTAF);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '1',
                      OBSSTATUS  = V_ERRO
                WHERE IDPROCESSO = 'USR_ITEMAUTFDEST_NGD'
                  AND IDPESQITEM = C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.CDFILDEST||'-'||C_PRODUTOS.DTPROGENTAF;
               IF SQL%NOTFOUND THEN
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '1', V_ERRO, C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.CDFILDEST||'-'||C_PRODUTOS.DTPROGENTAF);
               END IF;
            END;
         END;
      END LOOP;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_ITEMAUTFDEST_NGD','6.37.015'); END;
/
