/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOFORN                                                 */
/* Tabela : TIPOFORN                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOFORN' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOFORN
GO

CREATE TRIGGER DTULTATU_TIPOFORN
ON TIPOFORN
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOFORN', null, 'CDTIPOFORN='+ CDTIPOFORN+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOFORN
      SET DTULTATUTPFO = GETDATE()
      FROM INSERTED;
   END;
END;
GO

