function Dfs88000_Conhecimento_de_transporte_eletronico_Service(General, ZHPromise, localStorageEngine) {
    
    this.setDefaultCte = function(defaultMdfe) {
        return localStorageEngine.setDataSource("df#/defaultCte", defaultMdfe);
    };
    
    this.getDefaultCte = function() {
        return localStorageEngine.getDataSource("df#/defaultCte");
    };
    
    this.buildFilter = function(row) {
        var filter = [];

        for (let fieldName of ['REMETCDCLIENTE', 'REMETCDFORNECED', 'EXPCDCLIENTE', 'EXPCDFORNECED', 'RECEBCDCLIENTE', 'RECEBCDFORNECED', 'DESTCDCLIENTE', 'DESTCDFORNECED', 'TOMADCDCLIENTE', 'TOMADCDFORNECED']) {
            if (row[fieldName]) {
                filter.push( { "name": "P_"+fieldName, "value": row[fieldName], "operator": "=" } );
            }
        }
        
        for (let fieldName of ['CDEMPRESA', 'IDSTATUSCTE', 'IDCADDESTINATA', 'IDCADTOMADOR', 'IDCADREMETENTE', 'IDCADEXPEDIDOR', 'IDCADRECEBEDOR']) {
            if (row[fieldName]) {
                filter.push( { "name": fieldName, "value": row[fieldName], "operator": "=" } );
            }
        }
    
        if (row.NRINSESTEMIT) {
            filter.push( { "name": "CDINSCESTA", "value": row.NRINSESTEMIT, "operator": "=" } );
        }
        
        if (row.DTEMISSAO) {
            filter.push( { "name": "DTEMISSAO", "value": [row.DTEMISSAO.start, moment(row.DTEMISSAO.end, "DD/MM/YY hh:mm:ss").add(1, "days").format("DD/MM/YYYY")], "operator": "BETWEEN" } );
        }
        
        return filter;
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs88000_Conhecimento_de_transporte_eletronico_Service", Dfs88000_Conhecimento_de_transporte_eletronico_Service);
});
