function blockMove() {
	event.preventDefault();
}
var ZeedhiApp = angular.module("ZeedhiApp", [
	'ui.bootstrap.tpls',
	'ZeedhiServices',
	'ZeedhiDirectives',
	'ZeedhiDiretiveDate',
	'ZeedhiFilters',
	'ZeedhiChart',
	'ZeedhiReference',
	'ZeedhiEvents',
	'ZeedhiInterations',
	'ZeedhiReference',
	'ZeedhiController',
	'ZeedhiTodo',
	'ZeedhiFields',
	'ngTouch',
	'pasvaz.bindonce',
	'ngSanitize',
	'ui.sortable',
	'angular-iscroll'
]);
/*
 * CORS support
 */
ZeedhiApp.config(function($httpProvider) {
	$httpProvider.defaults.useXDomain = true;
	delete $httpProvider.defaults.headers.common['X-Requested-With'];
});

ZeedhiApp.run(function($injector) {
	if (window.zhControllers) {
		window.zhControllers.forEach(function(controller) {
			ZeedhiApp.controller(controller.name, function() {
				var serviceInstance = $injector.instantiate(controller.controller);
				return serviceInstance;
			});
		});
	}
});

ZeedhiApp.run(function(templateManager, restEngine) {
	window.__changeURI = function(uri) {
		var serviceUrl = uri || window.serviceUrl;
		var serviceUrls = window.serviceUrls || [];
		templateManager.buildMapOfServicePackages(serviceUrl, serviceUrls);
		localStorage.setItem("ZeedhiServiceURI-" + templateManager.project.name, serviceUrl);
		templateManager.updateTemplate();
	};
	window.__resetURI = function() {
		localStorage.removeItem("ZeedhiServiceURI");
		templateManager.buildMapOfServicePackages(window.serviceUrl, window.serviceUrls);
		templateManager.updateTemplate();
	};
});

(function() {
	var rootScope;
	var templateManagerObject;

	ZeedhiApp.run(function($rootScope, templateManager) {
		rootScope = $rootScope;
		$rootScope.Util = window.Util;
		templateManagerObject = templateManager;
	});

	ZeedhiApp.config(function($httpProvider, $provide, $controllerProvider, $compileProvider) {
		$provide.decorator('$exceptionHandler', ['$log', '$delegate',
			function($log, $delegate) {
				return function(exception, cause) {
					ErrorReporting.__error(exception.message + exception.stack+': '+cause);
					$delegate(exception, cause);
				};
			}
		]);

		$httpProvider.interceptors.push('loader');
		var spinnerFunction = function(data) {

			if ((!data || !JSON.parse(data).disableLoader) && !templateManagerObject.project.newLoaderMode) {
				rootScope.$broadcast("loader.show");
			}

			return data;
		};
		$httpProvider.defaults.transformRequest.push(spinnerFunction);

		// compatibiity with angular 1.2.x
		$controllerProvider.allowGlobals();

		$compileProvider.debugInfoEnabled(false);
	});

 	ZeedhiApp.factory('loader', function($q) {
		return {
			response: function(response) {
				if (!templateManagerObject.project.newLoaderMode && (!response.config.data || !response.config.data.disableLoader)) rootScope.$broadcast("loader.hide");
				return response;
			},
			responseError: function(response) {
 				if (!templateManagerObject.project.newLoaderMode && (!response.config.data || !response.config.data.disableLoader)) rootScope.$broadcast("loader.hide");
 				return $q.reject(response);
			}
 		};
	});

})();